########################################################################
# File Name: adventure.py
# 
# Author: Robert Gervais
# 
# Date: 5/02/2012
#
# Purpose: A simple text adventure game.
# 
# GPL Notice:    
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
########################################################################

from os.path import isfile
from os import system

############################################
#
# UTILITY FUNCTIONS
#
# -FileSystem
#   This function checks to see if a file
#   exists. If the file doesn't exist, it
#   throws out an exception. If the file
#   exists, it opens the file, reads the
#	contents into a string buffer, then
#	prints the string buffer to the console.
#
# -Concat Function
#   This function concatenates a number
#   with a string to provide the appropriate
#	text filename.
#
###########################################

############################################
# Method: FileSystem
# Parameter: fileName (string)
############################################
def FileSystem(fileName):
	isfile('adventureLevels' + fileName)
	try:
		target = open('adventureLevels/' + fileName)
	except IOError as e:
		print "Page doesn't exist... Try another page."
		return 1
	toPrint = target.read()
	if toPrint:
		print "%s" % toPrint
		target.close()
		return 1
	else:
		print "There is nothing to read in this page... Try another page."
		return 1
	return response

############################################
# Method: Concat
# Parameter: filenumber (int)
############################################
def Concat(filenumber):
	return filenumber + ".txt"

############################################
#
# GAME LOGIC FUNCTIONS
#
# -Start Function
#   This function starts and restarts the
#   game.
#
# -Think Function
#   This function implements game logic.
#
###########################################

############################################
# Method: StartGame
# Parameter: None
############################################
def StartGame():
	system('clear')
	startingFile = Concat('about')
	start_result = FileSystem(startingFile)
	return start_result

############################################
# Method: Think
# Parameter: fileName (string)
############################################
def Think(fileName):
	if fileName == '0.txt':
		system('clear')
		FileSystem(fileName)
		exit()
	elif fileName == 'restart.txt':
		system('clear')
		StartGame()
		return 1
	elif fileName == 'instructions.txt':
		system('clear')
		FileSystem(fileName)
		return 1
	elif fileName == 'intro.txt':
		system('clear')
		FileSystem(fileName)
		return 1
	else:
		system('clear')
		FileSystem(fileName)
		return 1

result = StartGame() #start the game

############################################
# GAME LOOP
############################################
while result == 1:
	fileNumber = raw_input("\nWhat page should I open? (0 to exit/restart to begin anew)> ")
	f_name = Concat(fileNumber)
	result = Think(f_name)
